package at.ac.uibk.gitsearch.service;

import at.ac.uibk.gitsearch.GitsearchApp;
import at.ac.uibk.gitsearch.service.dto.BroadCastMessageDTO;
import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;
import java.io.IOException;
import org.hamcrest.MatcherAssert;
import org.hamcrest.Matchers;
import org.junit.Assert;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest(classes = GitsearchApp.class)
public class MessageServiceIT {

    @Autowired
    MessageService messageService;

    @Test
    public void loadMessages() throws JsonParseException, JsonMappingException, IOException {
        BroadCastMessageDTO[] messages = messageService.getMessages();
        if (messages == null) {
            // give it more time (or trigger reload)
            messageService.triggerReload();
            messages = messageService.getMessages();
        }

        Assert.assertNotNull("This may fail, due to timing problems", messages);
        MatcherAssert.assertThat("This may fail, if there are no messages in gitlab", messages, Matchers.arrayWithSize(2));
    }
}
